com.jnape.palatable.lambda.functions.builtin.fn2

## Class Zip<A,B>

- java.lang.Object
- - com.jnape.palatable.lambda.functions.builtin.fn2.Zip<A,B>

- Type Parameters:
    `A` - The first input Iterable element type, and the type of the first tuple slot in the output Iterable
    `B` - The second input Iterable element type, and the type of the second tuple slot in the output Iterable
  All Implemented Interfaces:
    Fn1<Iterable<A>,Fn1<Iterable<B>,Iterable<Tuple2<A,B>>>>, Fn2<Iterable<A>,Iterable<B>,Iterable<Tuple2<A,B>>>, Applicative<Fn1<Iterable<B>,Iterable<Tuple2<A,B>>>,Fn1<Iterable<A>,?>>, Cartesian<Iterable<A>,Fn1<Iterable<B>,Iterable<Tuple2<A,B>>>,Fn1<?,?>>, Cocartesian<Iterable<A>,Fn1<Iterable<B>,Iterable<Tuple2<A,B>>>,Fn1<?,?>>, Contravariant<Iterable<A>,Profunctor<?,Fn1<Iterable<B>,Iterable<Tuple2<A,B>>>,Fn1<?,?>>>, Functor<Fn1<Iterable<B>,Iterable<Tuple2<A,B>>>,Fn1<Iterable<A>,?>>, Profunctor<Iterable<A>,Fn1<Iterable<B>,Iterable<Tuple2<A,B>>>,Fn1<?,?>>, Monad<Fn1<Iterable<B>,Iterable<Tuple2<A,B>>>,Fn1<Iterable<A>,?>>, MonadReader<Iterable<A>,Fn1<Iterable<B>,Iterable<Tuple2<A,B>>>,Fn1<Iterable<A>,?>>, MonadRec<Fn1<Iterable<B>,Iterable<Tuple2<A,B>>>,Fn1<Iterable<A>,?>>, MonadWriter<Iterable<A>,Fn1<Iterable<B>,Iterable<Tuple2<A,B>>>,Fn1<Iterable<A>,?>>

      public final class Zip<A,B>
      extends Object
      implements Fn2<Iterable<A>,Iterable<B>,Iterable<Tuple2<A,B>>>

  Zip together two `Iterable`s into a single `Iterable` of `Tuple2<A, B>`. If the input `Iterable`s differ in size, the resulting `Iterable` contains only as many pairs as the smallest input `Iterable`'s elements.
  See Also:
    `ZipWith`

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Iterable<Tuple2<A,B>>` | `checkedApply(Iterable<A> as, Iterable<B> bs)`
    `static <A,B> Zip<A,B>` | `zip()`
    `static <A,B> Fn1<Iterable<B>,Iterable<Tuple2<A,B>>>` | `zip(Iterable<A> as)`
    `static <A,B> Iterable<Tuple2<A,B>>` | `zip(Iterable<A> as, Iterable<B> bs)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn2

      `apply, apply, checkedApply, compose, contraMap, curried, curry, diMapL, discardR, flip, fn2, fromBiFunction, toBiFunction, uncurry, widen`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn1

      `andThen, carry, cartesian, censor, choose, cocartesian, diMap, diMapR, discardL, flatMap, fmap, fn1, fromFunction, lazyZip, listens, local, pure, pureFn1, thunk, toFunction, trampolineM, zip, zip`

    - ### Methods inherited from interface com.jnape.palatable.lambda.monad.Monad

      `join`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functor.Functor

      `coerce`

- - ### Method Detail

    - #### checkedApply

          public Iterable<Tuple2<A,B>> checkedApply(Iterable<A> as,
                                                    Iterable<B> bs)

      Specified by:
        `checkedApply` in interface `Fn2<Iterable<A>,Iterable<B>,Iterable<Tuple2<A,B>>>`

    - #### zip

          public static <A,B> Zip<A,B> zip()

    - #### zip

          public static <A,B> Fn1<Iterable<B>,Iterable<Tuple2<A,B>>> zip(Iterable<A> as)

    - #### zip

          public static <A,B> Iterable<Tuple2<A,B>> zip(Iterable<A> as,
                                                        Iterable<B> bs)